=== modified file 'dashboard_app/extension.py'
--- dashboard_app/extension.py	2011-05-25 13:22:26 +0000
+++ dashboard_app/extension.py	2011-06-17 01:33:55 +0000
@@ -28,11 +28,11 @@
     def contribute_to_settings(self, settings):
         super(DashboardExtension, self).contribute_to_settings(settings)
         settings['INSTALLED_APPS'].extend([
-            "pagination",
+            "linaro_django_pagination",
             "south",
         ])
         settings['MIDDLEWARE_CLASSES'].append(
-            'pagination.middleware.PaginationMiddleware')
+            'linaro_django_pagination.middleware.PaginationMiddleware')
         settings['RESTRUCTUREDTEXT_FILTER_SETTINGS'] = {
             "initial_header_level": 4}
         # TODO: Add dataview database support

=== modified file 'dashboard_app/helpers.py'
--- dashboard_app/helpers.py	2011-05-07 23:30:43 +0000
+++ dashboard_app/helpers.py	2011-06-17 01:33:55 +0000
@@ -8,11 +8,9 @@
 
 from django.core.files.base import ContentFile
 from django.db import transaction, IntegrityError
-from linaro_dashboard_bundle import (
-    DocumentIO,
-    DocumentEvolution,
-    DocumentFormatError
-)
+from linaro_dashboard_bundle.errors import DocumentFormatError
+from linaro_dashboard_bundle.evolution import DocumentEvolution
+from linaro_dashboard_bundle.io import DocumentIO
 from linaro_json.extensions import datetime_extension, timedelta_extension
 
 

=== modified file 'dashboard_app/tests/models/bundle.py'
--- dashboard_app/tests/models/bundle.py	2011-05-23 17:02:43 +0000
+++ dashboard_app/tests/models/bundle.py	2011-06-17 01:33:55 +0000
@@ -13,8 +13,8 @@
     BundleDeserializationError,
     BundleStream,
 )
-from launch_control.thirdparty.mocker import Mocker, expect
-from launch_control.utils.call_helper import ObjectFactoryMixIn
+from dashboard_app.tests.mocker import Mocker, expect
+from dashboard_app.tests.call_helper import ObjectFactoryMixIn
 
 
 class BundleTests(TestCase, ObjectFactoryMixIn):

=== modified file 'dashboard_app/tests/models/data_report.py'
--- dashboard_app/tests/models/data_report.py	2011-05-30 16:58:20 +0000
+++ dashboard_app/tests/models/data_report.py	2011-06-17 01:33:55 +0000
@@ -23,8 +23,8 @@
 from django.core.urlresolvers import reverse
 from django_testscenarios.ubertest import TestCase
 
-from launch_control.thirdparty.mocker import Mocker, expect
 from dashboard_app.models import DataReport
+from dashboard_app.tests.mocker import Mocker, expect
 
 
 class DataReportTests(TestCase):

=== modified file 'dashboard_app/tests/models/hw_device.py'
--- dashboard_app/tests/models/hw_device.py	2010-10-08 15:29:23 +0000
+++ dashboard_app/tests/models/hw_device.py	2011-06-17 01:33:55 +0000
@@ -6,7 +6,7 @@
 from django.test import TestCase
 
 from dashboard_app.models import HardwareDevice
-from launch_control.utils.call_helper import ObjectFactoryMixIn
+from dashboard_app.tests.call_helper import ObjectFactoryMixIn
 
 
 class HardwareDeviceTestCase(TestCase, ObjectFactoryMixIn):

=== modified file 'dashboard_app/tests/models/sw_package.py'
--- dashboard_app/tests/models/sw_package.py	2011-04-01 10:59:16 +0000
+++ dashboard_app/tests/models/sw_package.py	2011-06-17 01:33:55 +0000
@@ -6,7 +6,7 @@
 from django.test import TestCase
 
 from dashboard_app.models import SoftwarePackage
-from launch_control.utils.call_helper import ObjectFactoryMixIn
+from dashboard_app.tests.call_helper import ObjectFactoryMixIn
 
 
 class SoftwarePackageTestCase(TestCase, ObjectFactoryMixIn):

=== modified file 'dashboard_app/tests/other/dataview.py'
--- dashboard_app/tests/other/dataview.py	2011-05-18 21:42:17 +0000
+++ dashboard_app/tests/other/dataview.py	2011-06-17 01:33:55 +0000
@@ -20,6 +20,8 @@
 
 from dashboard_app.dataview import DataView
 
+from dashboard_app.tests.mocker import Mocker, expect
+
 
 class DataViewHandlerTests(unittest.TestCase):
 
@@ -76,7 +78,6 @@
 
     def test_get_connection_without_sandbox(self):
         # Mock connections['dataview'] to raise ConnectionDoesNotExist
-        from launch_control.thirdparty.mocker import Mocker, expect
         from django.db.utils import ConnectionDoesNotExist
         mocker = Mocker()
         connections = mocker.replace("django.db.connections")
@@ -94,7 +95,6 @@
         Test for DataView.get_connection()
         """
         # Mock connections['dataview'] to return special connection 
-        from launch_control.thirdparty.mocker import Mocker, expect
         from django.db.utils import ConnectionDoesNotExist
         mocker = Mocker()
         connections = mocker.replace("django.db.connections")

=== modified file 'dashboard_app/tests/other/deserialization.py'
--- dashboard_app/tests/other/deserialization.py	2011-05-23 17:02:43 +0000
+++ dashboard_app/tests/other/deserialization.py	2011-06-17 01:33:55 +0000
@@ -28,7 +28,7 @@
     TransactionTestCase,
 )
 from django.contrib.auth.models import User
-from linaro_dashboard_bundle import DocumentFormatError
+from linaro_dashboard_bundle.errors import DocumentFormatError
 from linaro_json.schema import ValidationError
 from linaro_json.extensions import datetime_extension
 

=== modified file 'setup.py'
--- setup.py	2011-05-25 11:04:28 +0000
+++ setup.py	2011-06-17 01:33:55 +0000
@@ -52,7 +52,7 @@
     ],
     install_requires = [
         'Django >= 1.2',
-        'django-pagination >= 1.0.7.1',
+        'linaro-django-pagination >= 2.0',
         'django-restricted-resource >= 0.2.5',
         'docutils >= 0.6',
         'lava-server',